<template>
  <v-layout align-center justify-center row wrap color="#f6f6f6">
    <v-dialog v-model="dialogLoader" persistent width="400">
      <v-card color="gray" dark>
        <v-card-text>
          Loading...
          <v-progress-linear
            indeterminate
            color="white"
            class="mb-0"
          ></v-progress-linear>
        </v-card-text>
      </v-card>
    </v-dialog>
    <v-flex xs12 pa-1>
      <v-card class="mx-auto my-12" elevation="0" width="100%" height="100%">
        <v-layout>
          <v-flex xs9>
            <div class="font-size-24-bold title-style">
              อัปโหลดรายการชำระเงิน
            </div>
          </v-flex>
          <v-flex xs3>
            <v-btn outline class="btn-download-form" href="/upload_example.xlsx">
              แบบฟอร์มตัวอย่าง
            </v-btn>
          </v-flex>
        </v-layout>
      </v-card>

      <div style="margin-top:4px">
        <v-card class="mx-auto my-12" elevation="0" width="100%" height="100%">
          <v-layout>
            <v-flex xs12>
              <v-form
                ref="formExcel"
                lazy-validation
                style="display: flex;justify-content: center;"
              >
                <div class="box-upload">
                  <center>
                    <img
                      :src="images.choosefile"
                      @click="$refs.fileExcel.click()"
                      style="cursor: pointer;"
                    />
                  </center>

                  <v-chip
                    class="black--text"
                    v-show="fileName"
                    style="font-family: Sarabun, sans-serif;"
                  >
                    {{ fileName }}
                    <v-icon class="ml-3 cursor-pointer" @click="clearFile()">
                      clear
                    </v-icon>
                  </v-chip>
                  <input
                    type="file"
                    ref="fileExcel"
                    style="display: none;"
                    @change="setFileName()"
                    accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
                  />
                  <br />
                  <v-btn
                    outline
                    depressed
                    round
                    style="color:#3A8300;font-family: Sarabun, sans-serif;font-weight: bold;"
                    v-if="isFile"
                    @click="uploadFile()"
                    >&ensp;&emsp;&emsp;Submit&emsp;&emsp;&ensp;</v-btn
                  >
                </div>
              </v-form>
              <div class="img-invoice" v-if="!showReview">
                <img :src="images.invoice" width="35%" />
              </div>
            </v-flex>
          </v-layout>

          <!-- <div>
        <br />
        <v-form ref="formExcel" lazy-validation> -->
          <!-- Sheet Name -->
          <!-- <p
            style="border: 2px dashed grey; text-align:center; background-color:#F3F3F3;"
          > -->
          <!-- <v-icon color="#2a95bf" large style="padding: 24px;">mdi-cloud-upload</v-icon><br> -->
          <!-- <v-icon color="#6a7d69" size="150px" style="padding: 24px;"
              >mdi-cloud-upload</v-icon
            ><br />
            <b>Upload Excel File</b>
            <v-layout
              align-center
              justify-start
              class="justify-center"
              style="margin: 10px 0 0 0;"
            >
              <v-flex xs4 v-if="!mobileView"
                ><a style="color:#cfb9b4;" href="/upload_example.xlsx"
                  >Download Example File</a
                ></v-flex
              >
              <v-flex xs6 v-if="mobileView"
                ><a style="color:#cfb9b4;" href="/upload_example.xlsx"
                  >Download Example File</a
                ></v-flex
              > </v-layout
            ><br /> -->

          <!-- Select File -->
          <!-- <v-layout
              align-center
              justify-start
              class="justify-center"
              style="margin: 10px 0 0 0;"
            >
              <v-flex xs2 v-if="!mobileView && isFile"
                ><p class="font-size-16">
                  Select File<span style="color: red;">&nbsp;*</span>
                </p></v-flex
              >
              <v-flex xs4 v-if="mobileView && isFile"
                ><p class="font-size-14">
                  Select File<span style="color: red;">&nbsp;*</span>
                </p></v-flex
              >
              <v-flex
                xs4
                style="text-align:left; padding: 0px 0px 0px 0px;"
                v-if="!mobileView"
              >
                <v-chip class="black--text" v-show="fileName">
                  {{ fileName
                  }}<v-icon class="ml-3 cursor-pointer" @click="clearFile()"
                    >clear</v-icon
                  >
                </v-chip>
              </v-flex>
              <v-flex
                xs6
                style="text-align:left; padding: 0px 0px 0px 0px;"
                v-if="mobileView"
              >
                <v-chip class="black--text" v-show="fileName">
                  {{ fileName
                  }}<v-icon class="ml-3 cursor-pointer" @click="clearFile()"
                    >clear</v-icon
                  >
                </v-chip>
              </v-flex> </v-layout
            ><br /> -->

          <!-- Browse -->
          <!-- <v-layout
              align-center
              justify-start
              class="justify-center"
              style="margin: 10px 0 0 0;"
            >
              <input
                type="file"
                ref="fileExcel"
                style="display: none;"
                @change="setFileName()"
                accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"
              />
              <v-btn
                round
                color="#6a7d69"
                @click="$refs.fileExcel.click()"
                style="color:#efdbd4;"
                >Choose File&nbsp;&nbsp;&nbsp;
                <v-icon>mdi-file-find</v-icon>
              </v-btn>
            </v-layout> -->

          <!-- Submit -->
          <!-- <v-layout
              align-center
              justify-start
              class="justify-center"
              style="margin: 10px 0 24px 0;"
            > -->
          <!-- <v-btn v-if="!statusUpload" round color="#2a95bf" style="color:white;" @click="uploadFile()">&ensp;&emsp;&emsp;Submit&emsp;&emsp;&ensp;</v-btn> -->
          <!-- ////////////////////////// -->
          <!-- <v-btn
                outline
                depressed
                round
                style="color:#6a7d69;"
                v-if="isFile"
                @click="uploadFile()"
                >&ensp;&emsp;&emsp;Submit&emsp;&emsp;&ensp;</v-btn
              >
            </v-layout>
          </p>
        </v-form> -->
          <div v-if="showReview" class="pt-4">
            <!-- <div class="font-size-24-bold">Review</div>
          <br /> -->
            <v-data-table
              :rows-per-page-items="rowperpage"
              :pagination.sync="pagination"
              :headers="headersMaster"
              :items="uploadData"
              class="elevation-1 table-style"
            >
              <template v-slot:items="props">
                <td class="text-xs-left">{{ props.item.order_id }}</td>
                <td class="text-xs-left">{{ props.item.doc_date }}</td>
                <td
                  class="text-xs-left"
                  style="min-width:200px;max-width: 200px;"
                >
                  {{ props.item.detail }}
                </td>
                <td class="text-xs-left">{{ props.item.receiver_company }}</td>
                <td class="text-xs-right">{{ props.item.receiver_tax_id }}</td>
                <td class="text-xs-left">{{ props.item.receiver_account_name }}</td>
                <td class="text-xs-left">{{ props.item.receiver_account_no }}</td>
                <td class="text-xs-center">
                  {{ props.item.receiver_bank_code }}
                </td>
                <td class="text-xs-left">{{ props.item.receiver_type }}</td>
                <td class="text-xs-left">{{ props.item.receiver_email }}</td>
                <td class="text-xs-right">{{ props.item.income_type }}</td>
                <td class="text-xs-right">{{ props.item.amount_exc_vat }}</td>
                <td class="text-xs-right">{{ props.item.vat_amount }}</td>
                <td class="text-xs-right">{{ props.item.wht_rate }}</td>
                <td class="text-xs-right">{{ props.item.wht_amount }}</td>
                <td class="text-xs-right">{{ props.item.wht_condition }}</td>
                <td class="text-xs-left">{{ props.item.payer_tax_id }}</td>

                <td
                  v-if="
                    props.item.action_description &&
                      props.item.action_description !== 'skip' &&
                      props.item.action_description !== 'overwrite'
                  "
                  class="text-xs-center"
                  style="color:#F44336;"
                >
                  {{ props.item.action_description }}
                  <v-layout>
                    <v-btn
                      v-if="
                        props.item.action_description ===
                          'Duplicate Doc No. in excel file' ||
                          props.item.action_description ===
                            'Duplicate Doc No.' ||
                          props.item.action_description ===
                            'This Doc No. has been processed'
                      "
                      round
                      @click="skip(props.item.no)"
                      class="btn-skip"
                      >Skip
                    </v-btn>
                    <v-btn
                      v-if="
                        props.item.action_description === 'Duplicate Doc No.'
                      "
                      round
                      @click="overwrite(props.item.no)"
                      class="btn-replace"
                      >Replace</v-btn
                    >
                  </v-layout>
                </td>
                <td v-else class="text-xs-center">
                  <strong>{{ props.item.action_description }}</strong>
                </td>
              </template>
            </v-data-table>
            <br />
            <v-layout style="margin: 20px 0 24px 0;float: right;">
              <v-btn outline depressed @click="clearFile()" class="btn-cancle">
                Cancel
              </v-btn>
              <v-btn
                v-if="
                  statusUpload === 'confirm' || statusUpload === 'wait confirm'
                "
                class="btn-confirm"
                @click="confirm()"
                >Confirm
              </v-btn>
            </v-layout>
          </div>
        </v-card>
      </div>
      <!-- </div> -->
    </v-flex>
  </v-layout>
</template>

<script>
import { sync } from "vuex-pathify";
import moment from "moment";
import Swal from "sweetalert2";
moment.locale("en");
export default {
  data() {
    return {
      mobileView: false,
      sheetName: "Sheet1",
      fileName: "",
      isFile: false,
      createdBy: this.$cookies.get("createdBy"),
      dialogLoader: false,
      showReview: false,
      headersMaster: [
        {
          text: "Doc No.",
          align: "left",
          sortable: false,
          value: "order_id"
        },
        { text: "Doc Date", align: "left", sortable: false, value: "doc_date" },
        { text: "Detail", align: "left", sortable: false, value: "detail" },
        // {
        //   text: "Company ID",
        //   align: "left",
        //   sortable: false,
        //   value: "company_id"
        // },
        {
          text: "Receiver Company",
          align: "left",
          sortable: false,
          value: "receiver_company"
        },
        {
          text: "Receiver Tax ID",
          align: "left",
          sortable: false,
          value: "receiver_tax_id"
        },
        {
          text: "Receiver Account Name",
          align: "left",
          sortable: false,
          value: "receiver_account_name"
        },
        {
          text: "Receiver Account No",
          align: "left",
          sortable: false,
          value: "receiver_account_no"
        },
        {
          text: "Receiver Bank Code",
          align: "center",
          sortable: false,
          value: "receiver_bank_code"
        },
        {
          text: "Receiver Type",
          align: "left",
          sortable: false,
          value: "receiver_type"
        },
        {
          text: "Receiver Email",
          align: "left",
          sortable: false,
          value: "receiver_email"
        },
        {
          text: "Income Type",
          align: "right",
          sortable: false,
          value: "income_type"
        },
        {
          text: "Amount",
          align: "right",
          sortable: false,
          value: "amount_exc_vat"
        },
        {
          text: "VAT",
          align: "right",
          sortable: false,
          value: "vat_amount"
        },
        {
          text: "WHT Rate",
          align: "right",
          sortable: false,
          value: "wht_rate"
        },
        {
          text: "WHT",
          align: "right",
          sortable: false,
          value: "wht_amount"
        },
        {
          text: "WHT Condition",
          align: "right",
          sortable: false,
          value: "wht_condition"
        },
        {
          text: "Sender Tax ID",
          align: "left",
          sortable: false,
          value: "payer_tax_id"
        },
        {
          text: "Action Description",
          align: "center",
          sortable: false,
          value: "action_description"
        }
        // { text: 'Wht Condition', align: 'right', sortable: false, value: 'wht_condition' },
      ],
      uploadData: [],
      statusUpload: "",
      statusOldUpload: "",
      setInterval: "",
      images: {
        choosefile: require("../assets/choosefile.png"),
        invoice: require("../assets/upload-invoice.png")
      },
      rowperpage: [
        5,
        10,
        25,
        { text: "$vuetify.dataIterator.rowsPerPageAll", value: -1 }
      ],
      pagination: {
        rowsPerPage: 10
      }
    };
  },
  methods: {
    addCommas(nStr) {
      nStr += "";
      var x = nStr.split(".");
      var x1 = x[0];
      var x2 = x.length > 1 ? "." + x[1] : "";
      var rgx = /(\d+)(\d{3})/;
      while (rgx.test(x1)) {
        x1 = x1.replace(rgx, "$1" + "," + "$2");
      }
      return x1 + x2;
    },
    decimalfixed(value) {
      let val = parseFloat(value).toFixed(2);
      return this.addCommas(val);
    },
    skip(index) {
      this.uploadData[index - 1].action_description = "skip";
    },
    overwrite(index) {
      this.uploadData[index - 1].action_description = "overwrite";
    },
    setFileName() {
      this.fileName = this.$refs.fileExcel.files[0].name;
      this.isFile = true;
    },
    clearFile() {
      // this.isFile = false
      // this.fileName = ''
      // this.$refs.formExcel.reset()
      location.reload();
    },
    checkUploadFile() {
      // console.log('checkUploadFile uploadData: ', this.uploadData);
      let validate = true;
      for (let i = 0; i < this.uploadData.length; i++) {
        if (
          this.uploadData[i].action_description &&
          this.uploadData[i].action_description !== "skip" &&
          this.uploadData[i].action_description !== "overwrite"
        ) {
          validate = false;
          break;
        }
      }
      if (validate === true) {
        this.statusUpload = "confirm";
        clearInterval(this.setInterval);
      }
    },
    async confirm() {
      // console.log('confirm');
      this.dialogLoader = true;
      // if (this.formatType === 'master') {
      if (this.statusOldUpload === "duplicate Invoice No in excel file") {
        this.statusOldUpload = "no duplicate Invoice No in excel file";
      } else if (
        this.statusOldUpload === "duplicate Invoice No" ||
        this.statusOldUpload === "wait confirm"
      ) {
        this.statusOldUpload = "confirm";
      }
      // }
      var { data: company_data } = await this.axios.post(
        process.env.VUE_APP_APIHOST + "/check_file_invoice",
        {
          data: this.uploadData,
          status: this.statusOldUpload
        },
        { headers: { Authorization: this.$cookies.get("token") } }
      );
      // console.log('check_file_company: ', company_data)
      this.dialogLoader = false;
      this.statusUpload = company_data.status;
      this.statusOldUpload = company_data.status;
      if (company_data.status === "success") {
        this.showReview = false;
        Swal.fire({
          title: "Upload Successful",
          text: "",
          icon: "success"
        }).then(function() {
          location.reload();
        });
      } else {
        this.uploadData = company_data.data;
        this.setInterval = setInterval(() => this.checkUploadFile(), 5000);
      }
    },
    async uploadFile() {
      try {
        if (this.$refs.formExcel.validate()) {
          if (this.isFile) {
            this.dialogLoader = true;
            var data = new FormData();
            data.append("createdBy", this.createdBy);
            data.append("file", this.$refs.fileExcel.files[0]);
            var { data: upload_data } = await this.axios.post(
              `${process.env.VUE_APP_APIHOST}/upload_file_invoice`,
              data,
              {
                headers: { Authorization: this.$cookies.get("token") }
              }
            );
            // console.log("upload_file_invoice: ", upload_data);
            this.dialogLoader = false;
            this.statusUpload = upload_data.status;
            this.statusOldUpload = upload_data.status;
            if (upload_data.status === "wait confirm") {
              this.showReview = true;
              this.uploadData = upload_data.data;
              clearInterval(this.setInterval);
            } else if (upload_data.status === "Incomplete format") {
              this.$swal("Upload Failed", upload_data.status, "error");
            } else {
              this.showReview = true;
              this.uploadData = upload_data.data;
              this.setInterval = setInterval(
                () => this.checkUploadFile(),
                5000
              );
            }
          } else {
            this.$swal("Upload Failed", "Choose File", "error");
          }
        }
      } catch (error) {
        console.log(error.message);
      }
    },
    handleView() {
      this.mobileView = window.innerWidth <= 990;
    }
  },
  created() {
    // console.log('username: ', this.userName)
    this.handleView();
    window.addEventListener("resize", this.handleView);
  }
};
</script>

<style>
table {
  width: 10%;
}
.mytable table th {
  border-bottom: none;
  font-weight: bolder;
}
.v-text-field input {
  font-size: 0.9em;
}
.v-input__slot {
  min-height: 26px !important;
}
.v-input__icon--prepend .v-icon {
  color: black;
}

.box-upload {
  display: flex;
  flex-direction: column;
  align-items: center;
  padding: 16px 160px;
  position: static;
  left: calc(50% - 511px / 2);
  top: calc(50% - 234px / 2);
  background: #e9fbdb;
  border: 1px dashed #5ccf00;
  box-sizing: border-box;
  border-radius: 6px;
  flex: none;
  order: 0;
  flex-grow: 0;
  margin: 16px 0px;
}

.btn-download-form {
  font-style: normal;
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  color: #3a8300 !important;
  border-radius: 4px;
  float: right;
  margin: 16px 30px 16px 0px;
  font-family: "Sarabun", sans-serif;
}

.text-sub {
  font-style: normal;
  font-weight: 500;
  font-size: 16px;
  line-height: 24px;
  color: #757575;
  margin: 8px 0px;
}

.img-invoice {
  display: flex;
  justify-content: center;
  margin-top: 50px;
}

.btn-confirm {
  background-color: #3a8300 !important;
  border-color: #3a8300;
  color: white !important;
  width: 200px;
  height: 40px;
  border-radius: 4px;
  font-family: "Sarabun", sans-serif;
}

.btn-cancle {
  color: #3a8300 !important;
  border-color: #3a8300;
  width: 200px;
  height: 40px;
  border-radius: 4px;
  font-family: "Sarabun", sans-serif;
}

.btn-skip {
  color: #3a8300 !important;
  text-decoration-line: underline;
  box-shadow: none !important;
  background-color: transparent !important;
}

.btn-replace {
  color: #d7b30b !important;
  text-decoration-line: underline;
  box-shadow: none !important;
  background-color: transparent !important;
}

/* .p-scrollpanel-content {
  height: auto !important;
  width: auto !important;
} */
</style>
